using System.Text.RegularExpressions;

class ch02_26
{
    static void Main()
    {
        string text = "Order number: 1234 Customer number: 5678";
            
        Regex regularExpression = 
            new Regex(@"Order number: (?<order>\d\d\d\d) " +
            @"Customer number: (?<customer>\d\d\d\d)");
        
        MatchCollection matches = regularExpression.Matches(text);

        foreach (Match match in matches)
        {
            if (match.Length != 0)               
            {
                System.Console.WriteLine("Order number: {0}", 
                    match.Groups["order"]);              
                System.Console.WriteLine("Customer number: {0}",
                    match.Groups["customer"]);              
            }       
        }           
    }
}       

