using System.Text.RegularExpressions;

class ch02_27
{
    static void Main()
    {
        string text = "Order, customer numbers: 1234, 5678";
            
        Regex regularExpression = 
            new Regex(@"(?<number>\d\d\d\d), (?<number>\d\d\d\d)");
        
        MatchCollection matches = regularExpression.Matches(text);

        foreach (Match match in matches)
        {
            if (match.Length != 0)               
            {
                foreach (Capture capture in 
                    match.Groups["number"].Captures)
                {
                    System.Console.WriteLine(capture);
                }
            }       
        }           
    }
}       

