public class ch04_08
{
    static void Main()
    {
        Window window = new Window(100, 200);
        window.Open();

        Menu menu = new Menu(100, 300);
        menu.Open();
    }
}

public class Window
{
    private Point location;

    public Window(int x, int y)
    {
        this.location = new Point(x, y);
    }

    public Window()
    {
        this.location = new Point(100, 100);
    }

    public virtual void Open()
    {
        System.Console.WriteLine("Opening window at [{0}, {1}]", 
        location.x, location.y);
    }

    protected class Point
    {
        public int x, y;

        public Point(int x, int y)
        {
            this.x = x;
            this.y = y;
        }
    }
}

public class Menu : Window
{
    private Point location;

    public Menu(int x, int y)
    {
        location = new Point(x, y);
    }

    public override void Open()
    {
        System.Console.WriteLine("Opening menu at [{0}, {1}]", 
        location.x, location.y);
    }

}
