public class ch04_10
{
   static void Main()
   {
      Window window = new Window();
      IOpenable iwindow;

      if (window is IOpenable){
         window.Open();
      }

      try
      {
          iwindow = window as IOpenable;
          iwindow.Open();
      }
      catch(System.InvalidCastException)
      {
          System.Console.WriteLine("Casting exception.");        
      }

      iwindow = window as IOpenable;
      
      if(iwindow != null){
          window.Open();
      }
   }
}

interface IOpenable
{
   void Open();
}

public class Window : IOpenable
{
   public void Open()
   {
      System.Console.WriteLine("Opening...");        
   }
}

