public class ch04_18
{
    public static void Main()
    {
        Button button = new Button();

        ButtonHandlerClass buttonHandler1 = new ButtonHandlerClass ();
        buttonHandler1.Subscribe(button);

        ButtonHandlerClass buttonHandler2 = new ButtonHandlerClass ();
        buttonHandler2.Subscribe(button);

        button.Click();
    }
}

public class Button
{
    public string name = "Button 1";
    public delegate void ButtonClickDelegate(object button, string text);

    public event ButtonClickDelegate OnClick;

    public void Click()
    {
        OnClick(this, "Clicked");
    }
}

public class ButtonHandlerClass
{
    public void Subscribe(Button button)
    {
        button.OnClick += new Button.ButtonClickDelegate(ButtonHandler);
    }

    public void ButtonHandler(object button, string text)
    {
        System.Console.WriteLine("{0} reports: {1}", 
            ((Button) button).name, text);
    }
}

