using System.IO;

public class ch05_07
{
    FileStream input;   
    byte[] dataBuffer;         
    System.AsyncCallback asyncDelegate; 

    public static void Main()
    {
         ch05_07 appObj = new ch05_07();           
         appObj.StartReading();
    }

    void StartReading()
    {
        input = new FileStream("ch05_07.cs", 
            FileMode.Open, FileAccess.Read, FileShare.None);
        dataBuffer = new byte[512];
        asyncDelegate = new System.AsyncCallback(this.OnBufferFull);

        input.BeginRead(dataBuffer, 0, dataBuffer.Length, asyncDelegate, null); 

        for (int loopIndex = 0; loopIndex < 1000000; loopIndex++){}
    }

    void OnBufferFull(System.IAsyncResult asyncResult)
    {
        int numberBytes = input.EndRead(asyncResult);
        System.Console.WriteLine(numberBytes);

        if (numberBytes > 0)
        {
            input.BeginRead(dataBuffer, 0, dataBuffer.Length, asyncDelegate, null);
        }
    }
}