public class ch06_11
{
    static void Main()
    {
        CustomerList customerList = new CustomerList("Ralph", "Ed", "Alice", "Trixie");

        System.Console.WriteLine("customerList[\"{0}\"] = {1}", 
            "zero", customerList["zero"]);
        System.Console.WriteLine("customerList[\"{0}\"] = {1}", 
            "one", customerList["one"]);
        System.Console.WriteLine("customerList[\"{0}\"] = {1}", 
            "two", customerList["two"]);
        System.Console.WriteLine("customerList[\"{0}\"] = {1}", 
            "three", customerList["three"]);
    }
}

public class CustomerList
{
    private string[] customers;
    private int number = 0;

    public CustomerList(params string[] customerNames)
    {
        customers = new string[100]; 

        foreach (string name in customerNames)
        {
            customers[number++] = name;
        }
    }

    public string this[int index]
    {
        get
        {
            return customers[index];
        }
        set
        {
            customers[index] = value;
        }
    }

    public string this[string index]
    {
        get
        {
            switch (index)
            {
                case "zero":
                    return customers[0];
                case "one":
                    return customers[1];
                case "two":
                    return customers[2];
                case "three":
                    return customers[3];
                default:
                    return "Out of bounds.";
            }
        }
        set
        {
            switch (index)
            {
                case "zero":
                    customers[0] = value;
                    break;
                case "one":
                    customers[1] = value;
                    break;
                case "two":
                    customers[2] = value;
                    break;
                case "three":
                    customers[3] = value;
                    break;
            }
        }
    }
}