public class ch06_15
{
    static void Main()
    {
        CustomerList customerList = new CustomerList("Ralph", "Ed", "Alice", "Trixie");
        string[] array = new string[4];
        customerList.CopyTo(array, 0);

        for (int loopIndex = 0; loopIndex < array.Length; loopIndex++)
        {
            System.Console.WriteLine("array[{0}] = {1}", 
                loopIndex, array[loopIndex]);
        }
    }
}

public class CustomerList
{
    private string[] customers;
    private int number = 0;

    public CustomerList(params string[] customerNames)
    {
        customers = new string[100]; 

        foreach (string name in customerNames)
        {
            customers[number++] = name;
        }
    }

    public void CopyTo(object[] array, int index)
    {
        if(index >= number){
            array = null;
            return;
        }
        for(int loopIndex = index; loopIndex < number; loopIndex++){
            array[loopIndex - index] = customers[loopIndex];
        }
    }

    public int Count
    {
        get
        {
            return number;
        }
    }

    public bool IsSynchronized
    {
        get
        {
            return true;
        }
    }

    public object SyncRoot
    {
        get
        {
            return this;
        }
    }

    public string this[int index]
    {
        get
        {
            return customers[index];
        }
        set
        {
            customers[index] = value;
        }
    }
}
