using System.IO;
using System.Security.Cryptography;

class ch13_09
{
    public static void Main() 
    {
        TripleDESCryptoServiceProvider cyptoProvider = 
            new TripleDESCryptoServiceProvider();

        FileStream fileStream = File.Create("c:\\c#\\ch13\\secret.dat");

        CryptoStream cryptoStream = new 
            CryptoStream(fileStream, cyptoProvider.CreateEncryptor(), 
            CryptoStreamMode.Write);

        StreamWriter streamWriter = new StreamWriter(cryptoStream);

        streamWriter.WriteLine("No worries!");
        streamWriter.Close();

        fileStream = File.Create("c:\\c#\\ch13\\secret.key");
        
        BinaryWriter binaryWriter = new BinaryWriter(fileStream);

        binaryWriter.Write(cyptoProvider.Key);
        binaryWriter.Write(cyptoProvider.IV);

        binaryWriter.Close();

        System.Console.WriteLine("Data encrypted, key stored.");
    }
}
