using System.Threading;

class ch15_03
{
    int counter = 0;

    static void Main()
    {
        ch15_03 app = new ch15_03();

        app.StartThreads();                 
    }

    public void StartThreads()
    {
        Thread thread1 = new Thread(new ThreadStart(CounterMethod1));
        thread1.Name = "Thread 1";
        thread1.Start();

        Thread thread2 = new Thread(new ThreadStart(CounterMethod2));
        thread2.Name = "Thread 2";
        thread2.Start();

        thread1.Join();
        thread2.Join();

        System.Console.WriteLine("All threads finished.");
    }

    public void CounterMethod1()
    {
        while (counter < 20)
        {
            Monitor.Enter(this);
            int localCounterValue = counter;
            if(localCounterValue < 20){
                Thread.Sleep(50);
                localCounterValue++; 
                Thread.Sleep(10);
                counter = localCounterValue;
                System.Console.WriteLine("Counter = {0} in {1}", 
                    counter, Thread.CurrentThread.Name);
            }
            Monitor.Exit(this);
        }
        System.Console.WriteLine("{0} done. ", Thread.CurrentThread.Name);
    }

    public void CounterMethod2()
    {
        while (counter < 20)
        {
            Monitor.Enter(this);
            int localCounterValue = counter;
            if(localCounterValue < 20){
                localCounterValue++; 
                Thread.Sleep(10);
                counter = localCounterValue;
                Thread.Sleep(5);

                System.Console.WriteLine("Counter = {0} in {1}", 
                    counter, Thread.CurrentThread.Name);
            }
            Monitor.Exit(this);
        }
        System.Console.WriteLine("{0} done. ", Thread.CurrentThread.Name);
    }
}
