using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;

public class Capitalizer : MarshalByRefObject, ICaps
{
    public string ToCaps(string inText)
    {
        System.Console.WriteLine("Got the text: \"{0}\"", inText);
        string outText = inText.ToUpper();
        System.Console.WriteLine("Sending back the text: \"{0}\"", outText);
        return outText;
    }
}

public class ch15_07
{
    public static void Main()
    {
        HttpChannel channel = new HttpChannel(65432);
        ChannelServices.RegisterChannel(channel);

        Type capitalizerType = Type.GetType("Capitalizer");

        RemotingConfiguration.RegisterWellKnownServiceType
           (capitalizerType, "EndPoint1", WellKnownObjectMode.Singleton );

        System.Console.WriteLine("Server is running, press Enter to quit.");
        System.Console.ReadLine();
    }
}
