using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
    
public class ch15_08 
{
    public static void Main()
    {

        HttpChannel channel = new HttpChannel();
        ChannelServices.RegisterChannel(channel);

        MarshalByRefObject marshalledObject = (MarshalByRefObject) RemotingServices.Connect
            (typeof(ICaps), "http://localhost:65432/EndPoint1");

        try
        {
            ICaps capper = (ICaps) marshalledObject;

            string outText = "No worries.";
            System.Console.WriteLine("Sending this text: \"{0}\"", outText);
            string inText = capper.ToCaps(outText);
            System.Console.WriteLine("Got this text back: \"{0}\"", inText);
        }
        catch(System.Exception e)
        {
            System.Console.WriteLine(e.Message);
        }
    }
}

