public class ch04_12
{
    static void Main()
    {
        Window window = new Window();
        window.Open();

        IComponent iwindow = window as IComponent;
        if (iwindow != null)
        {
            iwindow.Open();
        }
    }

}

interface IOpenable
{
    void Open();
}

interface IComponent
{
    void Open();
}

public class Window : IOpenable, IComponent
{
    void IComponent.Open()
    {
        System.Console.WriteLine("IComponent.Open opening...");
    }

    public void Open()
    {
        System.Console.WriteLine("IOpenable.Open opening...");
    }
}


