delegate void DisplayDelegate(string text);

public class ch04_17
{
    public static void Main()
    {
        DisplayDelegate Display, Debugger, SystemLog, multiCaster;

        Display = new DisplayDelegate(DisplayMethod);
        Debugger = new DisplayDelegate(DebuggerMethod);
        SystemLog = new DisplayDelegate(SystemLogMethod);

        multiCaster = Display + Debugger;
        System.Console.WriteLine("multiCaster = Display + Debugger");
        multiCaster("No worries.");
        System.Console.WriteLine();

        multiCaster += SystemLog;
        System.Console.WriteLine("multiCaster += SystemLog");
        multiCaster("No worries.");
        System.Console.WriteLine();

        multiCaster -= Display;
        System.Console.WriteLine("multiCaster -= Display");
        multiCaster("No worries.");
  }

    public static void DisplayMethod(string text)
    {
        System.Console.WriteLine("Sending to display: {0}", text);
    }

    public static void DebuggerMethod(string text)
    {
        System.Console.WriteLine("Sending to debug log: {0}", text);
    }

    public static void SystemLogMethod(string text)
    {
        System.Console.WriteLine("Sending to system log: {0}", text);
    }
}


