using System.IO;

class ch05_03
{
    public static void Main()
    {
        string currentDirectory =
            System.Environment.CurrentDirectory;

        DirectoryInfo dir = new DirectoryInfo(currentDirectory);

        DirectoryInfo backupDirectory = 
            dir.CreateSubdirectory("backup");

        FileInfo[] files = dir.GetFiles();

        foreach (FileInfo file in files)
        {
            string newName = backupDirectory.FullName +  
               @"\" + file.Name;
            file.CopyTo(newName);
        }
    }
}