using System.IO;
using System.Net; 
using System.Net.Sockets;

public class ch05_08
{
    public static void Main()
    {
        ch05_08 appObject = new ch05_08();
        appObject.Listen();
    }

    private void Listen()
    {
        TcpListener tcpListener = new TcpListener(IPAddress.Any, 65512);
        tcpListener.Start();       

        System.Console.WriteLine("Listening...");

        while(true)
        {
             Socket socket = tcpListener.AcceptSocket();

             if (socket.Connected)
             {
                 System.Console.WriteLine("Connected...");

                 NetworkStream networkStream = new NetworkStream(socket);
                 StreamWriter output = new StreamWriter(networkStream);
                 StreamReader input = new StreamReader("ch05_08.cs");
                 string inputString; 

                 System.Console.WriteLine("Sending...");

                 while((inputString = input.ReadLine()) != null)
                 {
                     output.WriteLine(inputString);
                     output.Flush();
                 }

                 networkStream.Close();
                 input.Close();
                 output.Close();
                 socket.Close();
   
                 System.Console.WriteLine("Disconnected...");

                 break;
            }
            System.Console.WriteLine("Quitting...");
        }
    }
}
