using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

[Serializable]
class ch05_13
{
    private int[] data;

    public static void Main()
    {
        System.Console.WriteLine("Creating an object...");
        ch05_13 obj = new ch05_13();

        ch05_13 deserializedObject = obj.Deserialize();
        deserializedObject.DisplayItems();
    }

    public ch05_13()
    {
        data = new int[3];
        data[0] = 1;
        data[1] = 2;
        data[2] = 3;
        Serialize();
    }

    private void DisplayItems()
    {
        System.Console.WriteLine("Displaying the object's items...");
        foreach (int value in data)
        {
            System.Console.WriteLine(value);
        }
    }

    private void Serialize()
    {
        System.Console.WriteLine("Serializing it...");
        FileStream output = new FileStream("ch05_13.out", FileMode.Create);
        BinaryFormatter formatter = new BinaryFormatter();
        formatter.Serialize(output, this);
        output.Close();
    }

    public ch05_13 Deserialize()
    {
        System.Console.WriteLine("Deserializing it...");
        FileStream input = new FileStream("ch05_13.out", FileMode.Open);
        BinaryFormatter formatter = new BinaryFormatter();
        return (ch05_13) formatter.Deserialize(input);
    }
}