using System;
using System.IO;
using System.IO.IsolatedStorage;

public class ch05_15
{
    public static void Main()
    {
        IsolatedStorageFileStream storage = 
             new IsolatedStorageFileStream("ch05_15.cfg", FileMode.Create);

        StreamWriter output = new StreamWriter(storage);

        output.WriteLine("Color = blue");
        output.Close();
        storage.Close();

        storage = new IsolatedStorageFileStream("ch05_15.cfg", FileMode.Open);
        StreamReader input = new StreamReader(storage);
        string item;

        while((item = input.ReadLine()) != null)
        {
            Console.WriteLine(item);
        } 

        input.Close();
        storage.Close();
    }
}

