using System.Collections;

public class ch06_13
{
    static void Main()
    {
        Customer[] customerArray = new Customer[4];

        customerArray[0] = new Customer("Ralph");
        customerArray[1] = new Customer("Ed");
        customerArray[2] = new Customer("Alice");
        customerArray[3] = new Customer("Trixie");
         
        System.Console.WriteLine("The customers:");
        for (int loopIndex = 0; loopIndex < customerArray.Length; loopIndex++)
        {
            System.Console.Write("{0} ", customerArray[loopIndex]);
        }
        System.Console.WriteLine();
        System.Console.WriteLine();

        System.Array.Sort(customerArray);

        System.Console.WriteLine("The sorted customers:");
        for (int loopIndex = 0; loopIndex < customerArray.Length; loopIndex++)
        {
            System.Console.Write("{0} ", customerArray[loopIndex]);
        }
        System.Console.WriteLine();
    }
}

public class Customer : System.IComparable
{
    private string name;

    public Customer(string name)
    {
         this.name = name;
    }

    public override string ToString()
    {
         return name;
    }

    public int CompareTo(object obj)
    {
         Customer customer = (Customer) obj;
         return this.name.CompareTo(customer.name);
    }
}
