using System.IO;
using System.Security.Cryptography;

class ch13_10
{
    public static void Main() 
    {
        TripleDESCryptoServiceProvider cyptoProvider = 
            new TripleDESCryptoServiceProvider();

        FileStream fileStream = File.OpenRead("c:\\c#\\ch13\\secret.key");
        
        BinaryReader binaryReader = new BinaryReader(fileStream);

        cyptoProvider.Key = binaryReader.ReadBytes(24);
        cyptoProvider.IV = binaryReader.ReadBytes(8);

        fileStream = File.OpenRead("c:\\c#\\ch13\\secret.dat");

        CryptoStream cryptoStream = new 
            CryptoStream(fileStream, cyptoProvider.CreateDecryptor(),
            CryptoStreamMode.Read);

        StreamReader streamReader = new StreamReader(cryptoStream);

        System.Console.WriteLine(streamReader.ReadLine());

        streamReader.Close();
    }
}
