#define DEBUGGING
using System;
using System.Diagnostics;

public class Debugger 
{
   [Conditional("DEBUGGING")] public static void Write(string text) 
   {
      System.Console.WriteLine(text);
   }
}

class ch14_01 
{
   static void Method1() 
   {
      Debugger.Write("Now in Method1.");
      Method2();
   }

   static void Method2() 
   {
      Debugger.Write("Now in Method2.");
   }

   public static void Main() 
   {
      Method1();
      System.Console.WriteLine("Did it work?");
   }
}
