using System;
using System.Reflection;

public class ch14_05
{
    public static void Main()
    {
        Type type = Type.GetType("System.Console");

        MemberInfo[] memberInfos = 
            type.FindMembers(MemberTypes.Method, 
            BindingFlags.Public | 
            BindingFlags.Static, 
            Type.FilterName, "Write*");

        foreach (MemberInfo member in memberInfos )
        {
            Console.WriteLine("{0}: {1}", member.MemberType, member);
        }
    }
}
