using System;
using System.Reflection;

public class Calculator
{
    public virtual long Addem(int x, int y) 
    {
        return x + y;
    }
}

class ch14_07
{
   public static void Main()
   {
      Type calculatorType = Type.GetType("Calculator");
      Object calculator = Activator.CreateInstance(calculatorType);

      Type[] parameterTypes = new Type[2];
      parameterTypes[0]= Type.GetType("System.Int32");
      parameterTypes[1]= Type.GetType("System.Int32");

      Type type = Type.GetType("Calculator");
      MethodInfo methodInfo = type.GetMethod("Addem", parameterTypes);

      Object[] parameters = new Object[2];
      parameters[0] = 2; 
      parameters[1] = 3; 

      System.Console.WriteLine("Addem(2, 3) = {0}",  
          methodInfo.Invoke(calculator, parameters));
   }
}
