using System;
using System.Diagnostics;

public class Counter
{
    public int CountLoop(int totalCount)
    {
        int total = 0;

        for(int loopIndex = 1; loopIndex <= totalCount; loopIndex++)
        {
            total++;
        }

        return total;
    }

    public int CountSimple()
    {
        return 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 
            1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 
            1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1;  
    }
}

public class ch14_08
{
    public static void Main()
    {
        Counter counter = new Counter();            
        int total = 0;

        DateTime begin = DateTime.Now;
        for (int loopIndex = 0; loopIndex < 10000000; loopIndex++)
        {
            total = counter.CountLoop(30);
        }
        TimeSpan duration = DateTime.Now - begin;

        System.Console.WriteLine("Looped to {0} 1,000,000 times in {1} milliseconds.", 
            total, duration.TotalMilliseconds);

        begin = DateTime.Now;
        for (int loopIndex = 0; loopIndex < 10000000; loopIndex++)
        {
            total = counter.CountSimple();
        }
        duration = DateTime.Now - begin;

        System.Console.WriteLine("Counted to {0} 1,000,000 times in {1} milliseconds.", 
            total, duration.TotalMilliseconds);
    }
}