using System;
using System.IO;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Serialization.Formatters.Soap;

public class Capitalizer : MarshalByRefObject, ICaps
{
    public string ToCaps(string inText)
    {
        System.Console.WriteLine("Got the text: \"{0}\"", inText);
        string outText = inText.ToUpper();
        System.Console.WriteLine("Sending back the text: \"{0}\"", outText);
        return outText;
    }
}

public class ch15_10
{
    public static void Main()
    {
        HttpChannel channel = new HttpChannel(65432);
        ChannelServices.RegisterChannel(channel);

        Capitalizer capitalizer = new Capitalizer();

        ObjRef objref = RemotingServices.Marshal(capitalizer);

        FileStream filestream = new FileStream("soap.txt", FileMode.Create);

        SoapFormatter soapformatter = new SoapFormatter();

        soapformatter.Serialize(filestream, objref);
        filestream.Close();

        System.Console.WriteLine("soap.txt created. Press Enter to quit.");
        System.Console.ReadLine();
    }
}


