using System;
using System.IO;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Serialization.Formatters.Soap;

public class ch15_11 
{
    public static void Main()
    {
        HttpChannel channel = new HttpChannel();
        ChannelServices.RegisterChannel(channel);

        FileStream filestream = new FileStream ("soap.txt", FileMode.Open);
        SoapFormatter soapformatter = new SoapFormatter();

        try
        {
            ICaps capper = (ICaps)soapformatter.Deserialize(filestream);

            string outText = "No worries.";
            System.Console.WriteLine("Sending this text: \"{0}\"", outText);
            string inText = capper.ToCaps(outText);
            System.Console.WriteLine("Got this text back: \"{0}\"", inText);
        }
        catch(System.Exception e)
        {
            System.Console.WriteLine(e.Message);
        }
    }
}
    
